#region Copyright Syncfusion Inc. 2001 - 2007
//
//  Copyright Syncfusion Inc. 2001 - 2007. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Diagram;
using Syncfusion.Windows.Forms.Diagram.Controls;

namespace Syncfusion.Windows.Forms.Diagram.Samples.DynamicSymbol
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
        #region Form controls
        private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram;
        private System.Windows.Forms.ImageList imageList;
        private System.Windows.Forms.ToolBar toolBar1;
        private System.Windows.Forms.PrintPreviewDialog printPreviewDialog1;
        private System.Windows.Forms.ToolBarButton toolBarButton1;
        private Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView paletteGroupView1;
        private System.Windows.Forms.Splitter splitter1;
        private System.Windows.Forms.ToolBarButton toolBarButton2;
        private System.ComponentModel.IContainer components;
		private Syncfusion.Windows.Forms.Diagram.Model model1;
        #endregion

        #region Class Initialize/Finalize methods
        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {

            InitializeComponent(); this.diagram.Model = this.model1;
            this.diagram.View.Grid.Visible = false;


        }

        /// <summary>
        /// Clean up any resources being used.
        /// </summary>
        protected override void Dispose( bool disposing )
        {
            if( disposing )
            {
                if (components != null) 
                {
                    components.Dispose();
                }
            }
            base.Dispose( disposing );
        }

        #endregion

        #region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainForm));
            this.diagram = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
            this.model1 = new Syncfusion.Windows.Forms.Diagram.Model();
            this.imageList = new System.Windows.Forms.ImageList(this.components);
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this.toolBarButton1 = new System.Windows.Forms.ToolBarButton();
            this.toolBarButton2 = new System.Windows.Forms.ToolBarButton();
            this.printPreviewDialog1 = new System.Windows.Forms.PrintPreviewDialog();
            this.paletteGroupView1 = new Syncfusion.Windows.Forms.Diagram.Controls.PaletteGroupView();
            this.splitter1 = new System.Windows.Forms.Splitter();
            ((System.ComponentModel.ISupportInitialize)(this.diagram)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.model1)).BeginInit();
            this.SuspendLayout();
            // 
            // diagram
            // 
            this.diagram.AllowDrop = true;
            this.diagram.Controller.PasteOffset = new System.Drawing.SizeF(10F, 10F);
            this.diagram.Dock = System.Windows.Forms.DockStyle.Fill;
            this.diagram.HScroll = true;
            this.diagram.LayoutManager = null;
            this.diagram.Location = new System.Drawing.Point(131, 28);
            this.diagram.Name = "diagram";
            this.diagram.ShowRulers = false;
            this.diagram.Size = new System.Drawing.Size(490, 411);
            this.diagram.SmartSizeBox = false;
            this.diagram.TabIndex = 0;
            // 
            // 
            // 
            this.diagram.View.Grid.Color = System.Drawing.Color.Black;
            this.diagram.View.MouseTrackingEnabled = false;
            this.diagram.View.PageBorderStyle.BorderColor = System.Drawing.Color.Black;
            this.diagram.View.PasteOffsetX = 0;
            this.diagram.View.PasteOffsetY = 0;
            this.diagram.VScroll = true;
            // 
            // model1
            // 
            this.model1.BackgroundStyle.Color = System.Drawing.Color.White;
            this.model1.BackgroundStyle.ForeColor = System.Drawing.Color.LightGray;
            this.model1.ShadowStyle.Color = System.Drawing.Color.DimGray;
            this.model1.ShadowStyle.ForeColor = System.Drawing.Color.DimGray;
            // 
            // imageList
            // 
            this.imageList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList.ImageStream")));
            this.imageList.TransparentColor = System.Drawing.Color.Transparent;
            this.imageList.Images.SetKeyName(0, "");
            this.imageList.Images.SetKeyName(1, "");
            // 
            // toolBar1
            // 
            this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.toolBarButton1,
            this.toolBarButton2});
            this.toolBar1.DropDownArrows = true;
            this.toolBar1.ImageList = this.imageList;
            this.toolBar1.Location = new System.Drawing.Point(0, 0);
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ShowToolTips = true;
            this.toolBar1.Size = new System.Drawing.Size(621, 28);
            this.toolBar1.TabIndex = 1;
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
            // 
            // toolBarButton1
            // 
            this.toolBarButton1.ImageIndex = 0;
            this.toolBarButton1.Name = "toolBarButton1";
            this.toolBarButton1.Tag = "InsertTool";
            this.toolBarButton1.ToolTipText = "Insert Symbol Tool";
            // 
            // toolBarButton2
            // 
            this.toolBarButton2.ImageIndex = 1;
            this.toolBarButton2.Name = "toolBarButton2";
            this.toolBarButton2.Tag = "InsertSymbols";
            this.toolBarButton2.ToolTipText = "Insert Symbols";
            // 
            // printPreviewDialog1
            // 
            this.printPreviewDialog1.AutoScrollMargin = new System.Drawing.Size(0, 0);
            this.printPreviewDialog1.AutoScrollMinSize = new System.Drawing.Size(0, 0);
            this.printPreviewDialog1.ClientSize = new System.Drawing.Size(400, 300);
            this.printPreviewDialog1.Enabled = true;
            this.printPreviewDialog1.Icon = ((System.Drawing.Icon)(resources.GetObject("printPreviewDialog1.Icon")));
            this.printPreviewDialog1.Name = "printPreviewDialog1";
            this.printPreviewDialog1.Visible = false;
            // 
            // paletteGroupView1
            // 
            this.paletteGroupView1.ButtonView = true;
            this.paletteGroupView1.Dock = System.Windows.Forms.DockStyle.Left;
            this.paletteGroupView1.Location = new System.Drawing.Point(0, 28);
            this.paletteGroupView1.Name = "paletteGroupView1";
            this.paletteGroupView1.Size = new System.Drawing.Size(128, 411);
            this.paletteGroupView1.TabIndex = 2;
            this.paletteGroupView1.Text = "paletteGroupView1";
            // 
            // splitter1
            // 
            this.splitter1.Location = new System.Drawing.Point(128, 28);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(3, 411);
            this.splitter1.TabIndex = 3;
            this.splitter1.TabStop = false;
            // 
            // MainForm
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.ClientSize = new System.Drawing.Size(621, 439);
            this.Controls.Add(this.diagram);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.paletteGroupView1);
            this.Controls.Add(this.toolBar1);
            this.Name = "MainForm";
            this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "Dynamic Symbol";
            ((System.ComponentModel.ISupportInitialize)(this.diagram)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.model1)).EndInit();
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

        #region MAIN
        /// <summary>
        /// The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main() 
        {
            Application.Run(new MainForm());
        }
        #endregion

        #region Class events
        /// <summary>
        /// 
        /// </summary>
        /// <param name="e"></param>
        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.LoadSymbolPalette();			
        }
        // Create a SymbolModel for the custom MySymbol and add it to the PaletteGroupView control
        protected void LoadSymbolPalette()
        {
			Node symbolNode = new ResiSpecSymbol();
			
            // Create a SymbolPalette for the PaletteGroupView control
			SymbolPalette palette = new SymbolPalette();
			palette.AppendChild(symbolNode );
            this.paletteGroupView1.LoadPalette(palette );
        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
        {
            if((string)e.Button.Tag == "InsertTool")
            {
				ResiSpecSymbol symbol = new ResiSpecSymbol();
				((IUnitIndependent)symbol).SetPinPoint( new PointF( 100,100 ) , MeasureUnits.Pixel );

				this.diagram.Model.AppendChild( symbol );
//                if (this.m_customSymbolMdl != null)
//                {
//                    Group sym = this.m_customSymbolMdl.CreateSymbol();
//
//                    // Set GraphicsPath location for symbol on bounds center.
//                    sym.X = - sym.Width / 2;
//                    sym.Y = - sym.Height / 2;
//                    
//                    if (sym != null)
//                    {
//                        this.diagram.ActivateTool("InsertMySymbol");
//                    }
//                }
            }
            else
            {
                // Temporarily suspend Model Redraw
                this.diagram.Model.BeginUpdate();

                // Use the InsertNodesCmd to insert the two symbols into the diagram
                NodeCollection symbols = new NodeCollection();

                ResiSpecSymbol symbol1 = new ResiSpecSymbol();
				symbol1.PinPoint = new PointF(10 + symbol1.PinPointOffset.Width, 10 + symbol1.PinPointOffset.Height);
				symbol1.EnableCentralPort = true;
                symbols.Add(symbol1);

                ResiSpecSymbol symbol2 = new ResiSpecSymbol();
				symbol2.PinPoint = new PointF(200, 200);
				symbol2.EnableCentralPort = true;
                symbols.Add(symbol2);


				int position = 0;

				LineConnector line = new LineConnector(symbol1.PinPoint, symbol2.PinPoint);

				symbols.Add( line );

				this.diagram.Model.AppendChildren(symbols, out position);

				symbol1.CentralPort.TryConnect(line.HeadEndPoint);
				symbol2.CentralPort.TryConnect(line.TailEndPoint);
			
				this.diagram.Model.EndUpdate();
            }			
        }
        #endregion
    }
}
