

#region Copyright Syncfusion Inc. 2001 - 2007
//
//  Copyright Syncfusion Inc. 2001 - 2007. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.ComponentModel;
using System.Runtime.Serialization;

using Syncfusion.Windows.Forms.Diagram;

using Syncfusion;
using System.IO;
using System.Runtime.Serialization.Formatters;
using System.Runtime.Serialization.Formatters.Binary;
using System.Runtime.Serialization.Formatters.Soap;
using System.Windows.Forms;

namespace Syncfusion.Windows.Forms.Diagram.Samples.DynamicSymbol
{
    /// <summary>
    /// Summary description for MySymbol.
    /// </summary>
    [Serializable()]
    public class ResiSpecSymbol : Group
    {
        #region Class members

        /// <summary>
        /// Symbol image part.
        /// </summary>
        private MetafileNode innerImage = null;

        #endregion




        #region Class Initialize/Finalize methods
        /// <summary>
        /// Default symbol constructor.
        /// </summary>
        public ResiSpecSymbol()
        {
            //////////////////////////////////////////////////////////////////
            // Add child nodes to the symbol programmatically
            //////////////////////////////////////////////////////////////////

            int ICON_WIDTH = 37;// image original size : 3717;
            int ICON_HEIGHT = 32;//image original size : 3279;

            string dir = System.IO.Path.GetDirectoryName(Application.ExecutablePath);

            this.innerImage = new MetafileNode(dir+"\\E273.wmf");
            this.innerImage.Size = new Size(ICON_WIDTH, ICON_HEIGHT);

            this.innerImage.Name = "Ellipse";
            this.innerImage.EditStyle.AllowSelect = false;
            this.innerImage.PinPoint = new PointF(ICON_WIDTH / 2, ICON_HEIGHT);
            this.AppendChild(innerImage);
        }


        /// <summary>
        /// Default symbol constructor.
        /// </summary>
        public ResiSpecSymbol(ResiSpecSymbol src)
            : base(src)
        {

            innerImage = (MetafileNode)this.GetChild(0);
        }
        /// <summary>
        /// Serialization constructor for symbols.
        /// </summary>
        /// <param name="info">Serialization state information</param>
        /// <param name="context">Streaming context information</param>
        protected ResiSpecSymbol(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }
        #endregion

        #region Class overrides
        /// <summary>
        /// Highlight over mouse symbol.
        /// </summary>
        /// <param name="evtArgs"></param>
        protected override void OnMouseEnter()
        {
            //this.upperRect.FillStyle.Color = Color.Green;

            base.OnMouseEnter();
        }


        /// <summary>
        /// Populates a SerializationInfo with the data needed to
        /// serialize the target object.
        /// </summary>
        /// <param name="info">SerializationInfo object to populate</param>
        /// <param name="context">Destination streaming context</param>
        protected override void GetObjectData(SerializationInfo info, StreamingContext context)
        {
            base.GetObjectData(info, context);
        }
        /// <summary>
        /// Clones this instance.
        /// </summary>
        /// <returns></returns>
        public override object Clone()
        {
            return new ResiSpecSymbol(this);
        }
        #endregion

    }

}

